#include <GUIConstantsEx.au3>
#include <ButtonConstants.au3>
#include <WindowsConstants.au3>
#include <Misc.au3>
#include <GuiTab.au3>
#include <StaticConstants.au3>
#include <GUIConstants.au3>
#include <Constants.au3>


Opt('MustDeclareVars', 1)
Opt("GUICoordMode", 1)

;-------------------------------------------
; reading configuration values from ini file 
;-------------------------------------------
Global $temp
Global $revision = IniRead("IM-simpleGUI.ini", "Main", "revision", "NotFound")
Global $file_input_1 = IniRead("IM-simpleGUI.ini", "Main", "file_input_1", "NotFound")
Global $file_input_2 = IniRead("IM-simpleGUI.ini", "Main", "file_input_2", "NotFound")
Global $file_output_1 = IniRead("IM-simpleGUI.ini", "Main", "file_output_1", "NotFound")
Global $image_viewer = IniRead("IM-simpleGUI.ini", "Main", "image_viewer", "NotFound")

;-------------------------------------------
; Define variables
;-------------------------------------------

Local $filemenu, $fileitem, $fileconfig, $separator1
Local $exititem, $helpmenu, $aboutitem, $okbutton, $cancelbutton

Local $Button_input_file1, $Button_input_file2, $Button_output_file1
Local $Label_input_file1, $Label_input_file2, $Label_output_file1
Local $input_file1 = $file_input_1
Local $input_file2 = $file_input_2
Local $output_file1 = $file_output_1

Local $Input_value, $msg

Local $Button_compare1, $Button_show_images, $Button_show_images2
Local $Button_show_input1, $Button_show_input2, $Button_show_output1
Local $Button_Edge_laplacian, $Button_Edge_sobel, $Button_Edge_prewitt



;-------------------------------------------
; Setting up the GUI 
;-------------------------------------------


Global $hGUI
$hGUI = GUICreate("IM-simpleGUI " & $revision, 360, 300, 100, 100)

Local $sFile = "favicon.ico"
GUISetIcon($sFile)

; top bar menu items
$filemenu = GUICtrlCreateMenu("File")
$fileconfig = GUICtrlCreateMenuItem("Config", $filemenu)
$exititem = GUICtrlCreateMenuItem("Exit", $filemenu)
$separator1 = GUICtrlCreateMenuItem("", $filemenu)
$helpmenu = GUICtrlCreateMenu("Help")
$aboutitem = GUICtrlCreateMenuItem("About", $helpmenu)

;info label on top
GUICtrlCreateLabel("Select files before processing.", 10, 10, 300, 40, $SS_SUNKEN)

;then add buttons and labels for files 
$Button_input_file1 = GUICtrlCreateButton("Input 1", 10, 60)
$Button_input_file2 = GUICtrlCreateButton("Input 2", 10, 90)
$Button_output_file1 = GUICtrlCreateButton("Output", 10, 120)

$Label_input_file1 = GUICtrlCreateLabel($file_input_1, 60, 62, 250, 20, $SS_SUNKEN)
$Label_input_file2 = GUICtrlCreateLabel($file_input_2, 60, 92, 250, 20, $SS_SUNKEN)
$Label_output_file1 = GUICtrlCreateLabel($file_output_1, 60, 122, 250, 20, $SS_SUNKEN)

$Button_show_input1 = GUICtrlCreateButton("Show", 320, 60)
$Button_show_input2 = GUICtrlCreateButton("Show", 320, 90)
$Button_show_output1 = GUICtrlCreateButton("Show", 320, 120)


; Differences components
$Button_compare1 = GUICtrlCreateButton("Compare 1", 10, 180)
GUICtrlSetTip($Button_compare1, "Compares 2 files and output differences in white with black background")
$Button_show_images = GUICtrlCreateButton("Show Images", 230, 180)
GUICtrlSetTip($Button_show_images, "Creates local file concatenated.png, and opens it in the specified viewer (see Config)")
GUICtrlCreateGroup("Differences", 5, 160, 305, 50)
GUICtrlCreateGroup("", -99, -99, 1, 1)


;Edge Detection components
$Button_Edge_laplacian = GUICtrlCreateButton("Laplacian", 10, 240)
GUICtrlSetTip($Button_Edge_laplacian, "Apply Edge Detection filter: Laplacian")
$Button_Edge_sobel = GUICtrlCreateButton("Sobel", 80, 240)
GUICtrlSetTip($Button_Edge_sobel, "Apply Edge Detection filter: Sobel")
$Button_Edge_prewitt = GUICtrlCreateButton("Prewitt", 130, 240)
GUICtrlSetTip($Button_Edge_prewitt, "Apply Edge Detection filter: Prewitt")
$Button_show_images2 = GUICtrlCreateButton("Show Images", 230, 240)
GUICtrlSetTip($Button_show_images2, "Creates local file concatenated.png, and opens it in the specified viewer (see Config)")
GUICtrlCreateGroup("Edge Detection", 5, 220, 305, 50)
GUICtrlCreateGroup("", -99, -99, 1, 1)

;Show the GUI and wait for buttons pressed
GUISetState()

;the main loop
While 1
	$msg = GUIGetMsg()
	Select
	  ; GUI actions
		Case $msg = $GUI_EVENT_CLOSE
			ExitLoop
		Case $msg = $exititem
			ExitLoop

		Case $msg = $fileconfig
			Run("notepad IM-simpleGUI.ini")

		Case $msg = $aboutitem
			MsgBox(0, "About", "This is simple example GUI execute some ImageMagick's commands." & _
					@LF & "Please feel free to extent and use as yo wish." & _
					@LF & "Wishes L. Sis, 2013")
			
       ; input and output files 
		Case $msg = $Button_input_file1
			;MsgBox(0, "Testing", "Button Button_input_file1 ")
			$input_file1 = FileOpenDialog("Choose file...", ".", "Images (*.png;*.bmp;*.tif)")
			If @error <> 1 Then GUICtrlSetData($Label_input_file1, $input_file1)
			
		Case $msg = $Button_input_file2
			;MsgBox(0, "Testing", "Button Button_input_file2 ")
			$input_file2 = FileOpenDialog("Choose file...", ".", "Images (*.png;*.bmp;*.tif)")
			If @error <> 1 Then GUICtrlSetData($Label_input_file2, $input_file2)

		Case $msg = $Button_output_file1
			;MsgBox(0, "Testing", "Button Button_input_file1 ")
			$output_file1 = FileOpenDialog("Choose file...", ".", "Images (*.png;*.bmp;*.tif)")
			If @error <> 1 Then GUICtrlSetData($Label_output_file1, $output_file1)

		Case $msg = $Button_show_input1
			Run($image_viewer & " " & $input_file1)

		Case $msg = $Button_show_input2
			Run($image_viewer & " " & $input_file1)

		Case $msg = $Button_show_output1
			Run($image_viewer & " " & $output_file1)


        ; differences section
		Case $msg = $Button_compare1
			Local $command_text1 = "compare -verbose -metric ae -compose Src -highlight-color White -lowlight-color Black "
			Local $command_text = $command_text1 & _
					$input_file1 & " " & $input_file2 & " " & $output_file1
			Execute_cmd($command_text)


		Case $msg = $Button_show_images
			Local $command_text1 = "montage -mode concatenate -tile 1x -frame 2 "
			Local $command_text = $command_text1 & _
					$input_file1 & " " & $input_file2 & " " & $output_file1 & " concatenated.png"
			Execute_cmd($command_text)
			Run($image_viewer & " concatenated.png")
			
        ; edge detection section

		Case $msg = $Button_Edge_laplacian
			Local $command_text1 = @ComSpec & " /c convert " & $input_file1 & " -define convolve:scale='!' -bias 50% -morphology Convolve Laplacian:1 "
			Local $command_text = $command_text1 & $output_file1
			Execute_cmd($command_text)

		Case $msg = $Button_Edge_sobel
			Local $command_text1 = @ComSpec & " /c convert " & $input_file1 & " -define convolve:scale='50%!' -bias 50% -morphology Convolve Sobel "
			Local $command_text = $command_text1 & $output_file1
			Execute_cmd($command_text)

		Case $msg = $Button_Edge_prewitt
			Local $command_text1 = @ComSpec & " /c convert " & $input_file1 & " -define convolve:scale='!' -bias 50% -morphology Convolve Prewitt  "
			;Local $command_text1 = @ComSpec & " /c convert " & $input_file1 & " -define convolve:scale='50%!' -bias 50% -morphology Convolve Prewitt  "
			Local $command_text = $command_text1 & $output_file1

			Execute_cmd($command_text)

		Case $msg = $Button_show_images2
			Local $command_text1 = "montage -mode concatenate -tile 1x -frame 2 "
			Local $command_text = $command_text1 & _
					$input_file1 & " " & $output_file1 & " concatenated.png"
			Execute_cmd($command_text)
			Run($image_viewer & " concatenated.png")

	EndSelect
WEnd

Func Execute_cmd($command_text)

	MsgBox(0, "Debugging, the command is", $command_text)
	ConsoleWrite("Debugging, the command is " & $command_text & @LF)
	Local $foo = Run($command_text, ".", @SW_HIDE, $STDERR_CHILD + $STDOUT_CHILD)

	Local $line
	While 1
		$line = StdoutRead($foo)
		If @error Then ExitLoop
		MsgBox(0, "STDOUT read:", $line)
	WEnd

	While 1
		$line = StderrRead($foo)
		If @error Then ExitLoop
		MsgBox(0, "STDERR read:", $line)
	WEnd

	Return
EndFunc   ;==>Execute_cmd


